# tempfile – Creates temporary files and directories

- Synopsis
- Parameters
- See Also
- Examples
- Return Values
- Status

## Synopsis

- The `tempfile` module creates temporary files and directories. `mktemp` command takes different parameters on various systems, this module helps to avoid troubles related to that. Files/directories created by module are accessible only by creator. In case you need to make them world-accessible you need to use file module.
- For Windows targets, use the win_tempfile module instead.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
path path |  | Location where temporary file or directory should be created. If path is not specified, the default system temporary directory will be used.
prefix string | Default: "ansible." | Prefix of file/directory name created by module.

state
string

Choices:
- directory
- file ←

Whether to create file or directory.

suffix string | Default: "" | Suffix of file/directory name created by module.

## See Also

See also

file – Manage files and file properties
  The official documentation on the file module.
win_tempfile – Creates temporary files and directories
  The official documentation on the win_tempfile module.

## Examples

    - name: create temporary build directory
      tempfile:
        state: directory
        suffix: build

    - name: create temporary file
      tempfile:
        state: file
        suffix: temp
      register: tempfile_1

    - name: use the registered var and the file module to remove the temporary file
      file:
        path: "{{ tempfile_1.path }}"
        state: absent
      when: tempfile_1.path is defined

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
path string | success | Path to created file or directory Sample: /tmp/ansible.bMlvdk

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Krzysztof Magosa (@krzysztof-magosa)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.